#include "compareData.h"

void compareData::compare(const ImportData & idata, const Problem & problem, const nodeData & nodeData)
{
	/*
	compareLoop(idata, problem, nodeData);
	compareDemand(idata, problem, nodeData);
	compareLayUp(idata, problem, nodeData);
	compareLayUpOperatingSunset(idata, problem, nodeData);
	compareInstalments(idata, problem, nodeData);
	compareScrapping(idata, problem, nodeData);
	compareCostToSunSet(idata, nodeData);
	compareCostToSunSet(idata, nodeData);
	*/
	
	
	
}

void compareData::compare(const ImportData & idata, const nodeData & nodeData, const string& outputDirectory, const string& stage, const string& scenario,
	const string& tree)
{
	if (CreateDirectory(outputDirectory.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) { // Creating the folder solutions

		string fullPath = outputDirectory + "\\" + instanceName;

		if (CreateDirectory(fullPath.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {	//Creating the folder "instanceName"

			fullPath = fullPath + "\\" + "AddOption_" + addOptionString;

			if (CreateDirectory(fullPath.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {

				fullPath = fullPath + "\\" + "BranchPeriod_" + branch;

				if (CreateDirectory(fullPath.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {	//Creating the folder "BranchPeriod_"

					fullPath += "\\" + stage + "_stage";

					if (CreateDirectory(fullPath.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {		//Creating the folder _stage

						fullPath += "\\" + scenario + "_scenarios";

						if (CreateDirectory(fullPath.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {	//Creating the folder _scenarios

							fullPath = fullPath + "\\" + "Tree_" + tree;

							if (CreateDirectory(fullPath.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {	//Creating the folder Tree_
								filePath = fullPath;
								compareSailOper(idata, nodeData);
								compareNodeData(idata, nodeData);
								//compareNodeDataMerged(idata, nodeData);

							}
							else {
								string error = "Failed creating directory : " + fullPath;
								char* cstr = new char[error.length() + 1];
								strcpy_s(cstr, error.length() + 1, error.c_str());
								throw cstr;
							}



						}
						else {
							string error = "Failed creating directory : " + fullPath;
							char* cstr = new char[error.length() + 1];
							strcpy_s(cstr, error.length() + 1, error.c_str());
							throw cstr;
						}

					}
					else {
						string error = "Failed creating directory : " + fullPath;
						char* cstr = new char[error.length() + 1];
						strcpy_s(cstr, error.length() + 1, error.c_str());
						throw cstr;
					}
				}
				else {
					string error = "Failed creating directory : " + fullPath;
					char* cstr = new char[error.length() + 1];
					strcpy_s(cstr, error.length() + 1, error.c_str());
					throw cstr;
				}

			}
			else {
				string error = "Failed creating directory : " + fullPath;
				char* cstr = new char[error.length() + 1];
				strcpy_s(cstr, error.length() + 1, error.c_str());
				throw cstr;
			}

		}

		else {
			string error = "Failed creating directory : " + fullPath;
			char* cstr = new char[error.length() + 1];
			strcpy_s(cstr, error.length() + 1, error.c_str());
			throw cstr;
		}
	}
	else {
		string error = "Failed creating directory : " + outputDirectory;
		char* cstr = new char[error.length() + 1];
		strcpy_s(cstr, error.length() + 1, error.c_str());
		throw cstr;
	}
}

void compareData::compareLoop(const ImportData & idata, const Problem & problem, const nodeData & nodeData)
{
	ofstream output;
	output.open("comparison.txt");

	for (int t = 1; t < idata.Time; t++) {
		map<string, int>::const_iterator iterShips;
		for (iterShips = idata.VoF[t].begin(); iterShips != idata.VoF[t].end(); iterShips++) {
			int v = iterShips->second;
			map<string, int>::const_iterator iterRoutes;
			for (iterRoutes = idata.RofVT[v][t].begin(); iterRoutes != idata.RofVT[v][t].end(); iterRoutes++) {
				int r = iterRoutes->second;
				map<int, int>::const_iterator iterNodes;
				for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
					int s = iterNodes->first;
					int node = iterNodes->second;

					output << "(" << iterShips->first << ", " << iterRoutes->first << ", " << t << ", " << s << ")\t \t" << problem.LoopCost[v][r][t][s] << "\t \t" 
						<< "(" << iterShips->first << ", " << iterRoutes->first << ", " << node << ")\t \t" << nodeData.LoopCost[v][r][node] << endl;

				}
			}
		}
	}


		output.close();
}

void compareData::compareLayUp(const ImportData & idata, const Problem & problem, const nodeData & nodeData)
{
	ofstream output;
	output.open("comparison.txt");

	for (int t = 1; t < idata.Time; t++) {
		map<string, int>::const_iterator iterShips;
		for (iterShips = idata.VoF[t].begin(); iterShips != idata.VoF[t].end(); iterShips++) {
			int v = iterShips->second;
			map<int, int>::const_iterator iterNodes;
			for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
				int s = iterNodes->first;
				int node = iterNodes->second;

				output << "(" << v << ", " << t << ", " << s << ")\t \t" << idata.RLU[v][t] << "\t \t"
					<< "(" << v << ", " << node << ")\t \t" << nodeData.RLU[v][node] << endl;

			}
		}
	}
	
	output.close();

}

void compareData::compareDemand(const ImportData & idata, const Problem & problem, const nodeData & nodeData)
{
	ofstream output;
	output.open("comparison.txt");

	for (int t = 1; t < idata.Time; t++) {
		map<string, int>::const_iterator iterTrades;
			for (iterTrades = idata.TradesOf[t].begin(); iterTrades != idata.TradesOf[t].end(); iterTrades++) {
				int i = iterTrades->second;
				for (int k = 0; k < idata.nProduct; k++){
				map<int, int>::const_iterator iterNodes;
				for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
					int s = iterNodes->first;
					int node = iterNodes->second;

					output << "(" << i << ", " << k << ", " << t << ", " << s << ")\t \t" << problem.Demand[i][k][t][s] << "\t \t"
						<< "(" << i << ", " << k << ", " << node << ")\t \t" << nodeData.Demand[i][k][node] << endl;

				}
			}
		}
	}


	output.close();
}

void compareData::compareLayUpOperatingSunset(const ImportData & idata, const Problem & problem, const nodeData & nodeData)
{
	ofstream output;
	output.open("comparison.txt");

	output << "Lay-up: " << endl;
	for (int t = 1; t < idata.Time; t++) {
		map<string, int>::const_iterator iterShips;
		for (iterShips = idata.VoF[t].begin(); iterShips != idata.VoF[t].end(); iterShips++) {
			int v = iterShips->second;
			map<int, int>::const_iterator iterNodes;
			for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
				int s = iterNodes->first;
				int node = iterNodes->second;
				map<int, int> temp = nodeData.AncestorNodes[t - 1];
				int a = temp[node];

				output << "(" << v << ", " << t << ", " << s << ")\t \t" << idata.RLU[v][t] << "\t \t"
					<< "(" << v << ", " << node << ")\t \t" << nodeData.RLU[v][node] << "\t \t"

					<< "(" << v << ", " << t << ", " << s << ")\t \t" << idata.OperatingCost[v][t] << "\t \t"
					<< "(" << v << ", " << node << ")\t \t" << nodeData.OperatingCost[v][node] << "\t \t";

				if (t == idata.Horizon) {
					output << "(" << v << ", " << t << ", " << s << ")\t \t" << problem.RSV[v][s] << "\t \t"
						<< "(" << v << ", " << node << ")\t \t" << nodeData.RSV[v][node] << "\t \t";
				}

					output << "(" << v << ", " << (t - 1) << ", " << s << ")\t \t" << problem.RSC[v][t - 1][s] << "\t \t"
					<< "(" << v << ", " << a << ")\t \t" << nodeData.RSC[v][a] << "\t \t" << endl;
					

			}
		}
	}

	output << "Operating cost: " << endl;
	for (int t = 1; t < idata.Time; t++) {
		map<string, int>::const_iterator iterShips;
		for (iterShips = idata.VoF[t].begin(); iterShips != idata.VoF[t].end(); iterShips++) {
			int v = iterShips->second;
			map<int, int>::const_iterator iterNodes;
			for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
				int s = iterNodes->first;
				int node = iterNodes->second;


			}
		}
	}

	output << "Sunset value: " << endl;
		map<string, int>::const_iterator iterShips;
		for (iterShips = idata.VoF[idata.Horizon].begin(); iterShips != idata.VoF[idata.Horizon].end(); iterShips++) {
			int v = iterShips->second;
			map<int, int>::const_iterator iterNodes;
			for (iterNodes = nodeData.NodesTime[idata.Horizon].begin(); iterNodes != nodeData.NodesTime[idata.Horizon].end(); iterNodes++) {
				int s = iterNodes->first;
				int node = iterNodes->second;
				
				

			}
		}


	output.close();

}

void compareData::compareInstalments(const ImportData & idata, const Problem & problem, const nodeData & nodeData)
{
	ofstream output;
	output.open("comparison.txt");

	for (int v = 0; v < idata.nShips; v++) {
		for (int tmarked = 0; tmarked < idata.Time - nodeData.buildTime; tmarked++) {
			for (int t = tmarked+1; t < tmarked + nodeData.M; t++) {
				bool flag = true;
				map<int, int>::const_iterator iterNodes;
				for (iterNodes = nodeData.InstalmentNodes[t].begin(); iterNodes != nodeData.InstalmentNodes[t].end(); iterNodes++) {
					int s = iterNodes->first;
					int node = iterNodes->second;
					map<int, int> temp = nodeData.AncestorInstalmentNodes[tmarked][t];
					int a = temp[node];

					if (flag) {
						output << "(" << v << ", " << tmarked << ", " << t-1 << ", " << s << ")\t \t" << problem.Instalment[v][tmarked][t-1][s] << "\t \t"
							<< "(" << v << ", " << a << ", " << a << ")\t \t" << nodeData.Instalment[v][a][a] << endl;
						flag = false;
					}

					output << "(" << v << ", " << tmarked << ", " << t << ", " << s << ")\t \t" << problem.Instalment[v][tmarked][t][s] << "\t \t"
						<< "(" << v << ", " << a << ", " << node << ")\t \t" << nodeData.Instalment[v][a][node] << endl;

				}
			}
		}
	}

		output.close();
}

void compareData::compareScrapping(const ImportData & idata, const Problem & problem, const nodeData & nodeData)
{
	ofstream output;
	output.open("comparison.txt");

	for (int t = 0; t < idata.Horizon; t++) {
		map<string, int>::const_iterator iterShips;
		for (iterShips = idata.VoF[t].begin(); iterShips != idata.VoF[t].end(); iterShips++) {
			int v = iterShips->second;
			map<int, int>::const_iterator iterNodes;
			for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
				int s = iterNodes->first;
				int node = iterNodes->second;

				output << "(" << v << ", " << t << ", " << s << ")\t \t" << problem.RSC[v][t][s] << "\t \t"
					<< "(" << v << ", " << node << ")\t \t" << nodeData.RSC[v][node] << endl;

			}
		}
	}

	output.close();

}

void compareData::compareCostToSunSet(const ImportData& idata, const nodeData & nodeData)
{
	ofstream output;
	output.open("comparison.txt");

	for (int t = 0; t < idata.Time-nodeData.buildTime; t++) {
		map<string, int>::const_iterator iterShips;
		for (iterShips = idata.VN[t+nodeData.buildTime].begin(); iterShips != idata.VN[t+nodeData.buildTime].end(); iterShips++) {
			int v = iterShips->second;
			map<int, int>::const_iterator iterNodes;
			for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
				int s = iterNodes->first;
				int node = iterNodes->second;

					

				output << "(" << v << ", " << t << ", " << s << ")\t \t" << nodeData.CNB[v][node] << endl;

			}

			

		}
	}
	map<string, int>::const_iterator iterShips;
	for (iterShips = idata.VoF[idata.Horizon].begin(); iterShips != idata.VoF[idata.Horizon].end(); iterShips++) {
		int v = iterShips->second;
		map<int, int>::const_iterator iterNodes;
		for (iterNodes = nodeData.NodesTime[idata.Horizon].begin(); iterNodes != nodeData.NodesTime[idata.Horizon].end(); iterNodes++) {
			int s = iterNodes->first;
			int node = iterNodes->second;

			output << "(" << v << ", " << idata.Horizon << ", " << s << ")\t \t" << nodeData.RSV[v][node] << endl;

		}
	}

	output.close();

}

void compareData::compareLoops(const ImportData & idata, const nodeData & nodeData)
{
	ofstream output("SailingCost.txt");

	output << " Ship \t" << "Route \t" << "Period 1 \t" << "Period 2 \t" << "Period 3 \t" << "Period 4 \t" << "Period 5 \t" << endl;

	map<string, int>::const_iterator iterRoutes;
	for (iterRoutes = idata.Routes.begin(); iterRoutes != idata.Routes.end(); iterRoutes++) {
		string route = iterRoutes->first;
		int r = iterRoutes->second;

	map<string, int>::const_iterator iterShips;
	for (iterShips = idata.Ships.begin(); iterShips != idata.Ships.end(); iterShips++) {
		string ship = iterShips->first;
		int v = iterShips->second;

			output << ship << "\t" << route << "\t";

			for (int t = 1; t < idata.Time; t++) {
				output << idata.LoopCost[v][r][t] << "\t";
			}
			output << endl;
		}
	}


	output.close();

}

void compareData::compareNodeLoops(const ImportData & idata, const nodeData & nodeData)
{
	ofstream output("NodeSailingCost.txt");

	output << " Ship \t" << "Route \t" << "Period \t" << "Scenario \t" << endl;

	for (int t = 1; t < idata.Time; t++) {

		map<int, int>::const_iterator iterNodes;

		for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
			int n = iterNodes->second;
			int s = iterNodes->first;

			map<string, int>::const_iterator iterRoutes;
			for (iterRoutes = idata.Routes.begin(); iterRoutes != idata.Routes.end(); iterRoutes++) {
				string route = iterRoutes->first;
				int r = iterRoutes->second;

				map<string, int>::const_iterator iterShips;
				for (iterShips = idata.Ships.begin(); iterShips != idata.Ships.end(); iterShips++) {
					string ship = iterShips->first;
					int v = iterShips->second;

					output << ship << "\t" << route << "\t" << t << "\t" << s << "\t";
					output << nodeData.LoopCost[v][r][n] << endl;


				}
			}
		}
	}


	output.close();
}

void compareData::compareNodeLayUpSavings(const ImportData & idata, const nodeData & nodeData)
{
	ofstream output("NodeLayUpSavings.txt");

	output << " Ship \t" << "Route \t" << "Period \t" << "Scenario \t" << endl;

	for (int t = 1; t < idata.Time; t++) {

		map<int, int>::const_iterator iterNodes;

		for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
			int n = iterNodes->second;
			int s = iterNodes->first;

				map<string, int>::const_iterator iterShips;
				for (iterShips = idata.Ships.begin(); iterShips != idata.Ships.end(); iterShips++) {
					string ship = iterShips->first;
					int v = iterShips->second;

					output << ship << "\t" << t << "\t" << s << "\t";
					output << nodeData.RLU[v][n] << endl;


				}
			}
		}


	output.close();
}

void compareData::compareNodeData(const ImportData & idata, const nodeData & nodeData)
{
	string filedirName = filePath + "\\CompareNodeData.txt";
	ofstream output(filedirName);

	output << "Ship \t" << "Trade \t" << "Product \t" << "Route \t" << "Period \t" << "Scenario \t" << "Lay-up savings \t" << "Operating cost \t" << "Scrapping value \t" 
		<< "Sunset value \t" << "Demand \t" << "Unit Revenue \t" << "Sailing cost \t" << "Space charter cost \t" << "Charter cost \t" << "New build cost \t" << "Second hand price \t" << endl;

	for (int t = 0; t < idata.Time; t++) {

		map<int, int>::const_iterator iterNodes;

		for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
			int n = iterNodes->second;
			int s = iterNodes->first;

			map<string, int>::const_iterator iterShips;
			for (iterShips = idata.Ships.begin(); iterShips != idata.Ships.end(); iterShips++) {
				string ship = iterShips->first;
				int v = iterShips->second;

				output << ship << "\t \t \t \t" << t << "\t" << s << "\t";

				if (t == idata.Horizon) {

					output << nodeData.RLU[v][n] << "\t" << nodeData.OperatingCost[v][n] << "\t" << nodeData.RSC[v][n] << "\t" << nodeData.RSV[v][n] << endl;

				}
				else {

					output << nodeData.RLU[v][n] << "\t" << nodeData.OperatingCost[v][n] << "\t" << nodeData.RSC[v][n] << "\t \t \t \t \t \t" << nodeData.CCI[v][n] << "\t" << nodeData.CNB[v][n] << "\t"
						<< nodeData.secondHand[v][n] << endl;

				}

				map<string, int>::const_iterator iterRoutes;
				for (iterRoutes = idata.Routes.begin(); iterRoutes != idata.Routes.end(); iterRoutes++) {
					string route = iterRoutes->first;
					int r = iterRoutes->second;

					output << ship << "\t \t \t" << route << "\t" << t << "\t" << s << "\t \t \t \t \t \t \t" << nodeData.LoopCost[v][r][n] << endl;

				}
			}

			map<string, int>::const_iterator iterTrades;
			for (iterTrades = idata.Trades.begin(); iterTrades != idata.Trades.end(); iterTrades++) {
				string trade = iterTrades->first;
				int i = iterTrades->second;

				map<string, int>::const_iterator iterProducts;
				for (iterProducts = idata.Product.begin(); iterProducts != idata.Product.end(); iterProducts++) {
					string product = iterProducts->first;
					int k = iterProducts->second;

					if (t > 0) {
						output << "\t" << trade << "\t" << product << "\t \t" << t << "\t" << s << "\t \t \t \t \t" << nodeData.Demand[i][k][n] << "\t" 
							<< nodeData.UnitRevenue[i][n] << "\t \t" << nodeData.CspaceC[i][k][n] << endl;
					}

				}
			}

			

		}
	}


	output.close();
}

void compareData::compareNodeDataMerged(const ImportData & idata, const nodeData & nodeData)
{
	string filedirName = filePath + "\\CompareNodeDataMerged.txt";
	ofstream output(filedirName);

	output << "ID \t" << "Ship \t" << "Trade \t" << "Product \t" << "Route \t" << "Period \t" << "Scenario \t" << "Lay-up savings \t" << "Operating cost \t" << "Scrapping value \t"
		<< "Sunset value \t" << "Demand \t" << "Unit Revenue \t" << "Sailing cost \t" << "Space charter cost \t" << "New build cost \t" << "Second hand price \t" << endl;

	long int counter = 1;
	for (int t = 0; t < idata.Time; t++) {

		map<int, int>::const_iterator iterNodes;

		for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
			int n = iterNodes->second;
			int s = iterNodes->first;

			map<string, int>::const_iterator iterShips;
			for (iterShips = idata.Ships.begin(); iterShips != idata.Ships.end(); iterShips++) {
				string ship = iterShips->first;
				int v = iterShips->second;

				map<string, int>::const_iterator iterRoutes;
				for (iterRoutes = idata.Routes.begin(); iterRoutes != idata.Routes.end(); iterRoutes++) {
					string route = iterRoutes->first;
					int r = iterRoutes->second;

					map<string, int>::const_iterator iterTrades;
					for (iterTrades = idata.Trades.begin(); iterTrades != idata.Trades.end(); iterTrades++) {
						string trade = iterTrades->first;
						int i = iterTrades->second;

						map<string, int>::const_iterator iterProducts;
						for (iterProducts = idata.Product.begin(); iterProducts != idata.Product.end(); iterProducts++) {
							string product = iterProducts->first;
							int k = iterProducts->second;

							

							if (t == idata.Horizon) {

								output << counter << "\t" << ship << "\t" << trade <<  "\t" << product << "\t"  << route << "\t" << t << "\t" << s << "\t" << nodeData.RLU[v][n] << "\t" 
									<< nodeData.OperatingCost[v][n] << "\t" << nodeData.RSC[v][n] << "\t" << nodeData.RSV[v][n] << "\t" << nodeData.Demand[i][k][n] << "\t"
									<< nodeData.UnitRevenue[i][n] << "\t" << nodeData.LoopCost[v][r][n] << "\t" << nodeData.CspaceC[i][k][n] << "\t" << nodeData.CNB[v][n] << "\t"
									<< nodeData.secondHand[v][n] << endl;

							}
							else {

								output << counter << "\t" << ship << "\t" << trade << "\t" << product << "\t" << route << "\t" << t << "\t" << s << "\t" << nodeData.RLU[v][n] << "\t"
									<< nodeData.OperatingCost[v][n] << "\t" << nodeData.RSC[v][n] << "\t" << "\t" << nodeData.Demand[i][k][n] << "\t"
									<< nodeData.UnitRevenue[i][n] << "\t" << nodeData.LoopCost[v][r][n] << "\t" << nodeData.CspaceC[i][k][n] << "\t" << nodeData.CNB[v][n] << "\t"
									<< nodeData.secondHand[v][n] << endl;

							}
							counter++;
						}
					}
				}
			}
		}
	}

	output.close();
}

void compareData::compareSailOper(const ImportData & idata, const nodeData & nodeData)
{
	string filedirName = filePath + "\\compareSailingOperating.txt";
	ofstream output(filedirName);

	output << "Ship \t" << "Route \t" << "Period \t" << "Scenario \t" << "Sailing cost \t" << "Sailing cost scenario \t"<< "Operating cost \t" << "Operating cost scenario \t" << "Duration \t" << endl;

	for (int t = 1; t < idata.Time; t++) {

		map<string, int>::const_iterator iterShips;
		for (iterShips = idata.VoF[t].begin(); iterShips != idata.VoF[t].end(); iterShips++) {
			int v = iterShips->second;
			string ship = iterShips->first;

			map<int, int>::const_iterator iterNodes;

			for (iterNodes = nodeData.NodesTime[t].begin(); iterNodes != nodeData.NodesTime[t].end(); iterNodes++) {
				int n = iterNodes->second;
				int s = iterNodes->first;

				map<string, int>::const_iterator iterRoutes;
				for (iterRoutes = idata.Routes.begin(); iterRoutes != idata.Routes.end(); iterRoutes++) {
					string route = iterRoutes->first;
					int r = iterRoutes->second;


					output << ship <<"\t" << route << "\t" << t << "\t" << s << "\t" << idata.LoopCost[v][r][t] << "\t" << nodeData.LoopCost[v][r][n] << "\t" << idata.OperatingCost[v][t] << "\t" << nodeData.OperatingCost[v][n] << "\t" << idata.Duration[v][r] << endl;

				}
			}

		}

	}




	output.close();
}

