#pragma once
#include "importData.h"
#include "Problem.h"
#include "nodeData.h"

class compareData {
public:
	compareData(const ImportData& idata, const Problem & problem, const nodeData& nodeData) { compare(idata, problem, nodeData); }

	compareData(const ImportData& idata, const nodeData& nodeData, const string& outputDirectory, const string& addOptionString, const string& instanceName, const string& branch, 
		const string& stage, const string& scenarios, const string& tree) : addOptionString(addOptionString), instanceName(instanceName), branch(branch) 
		{ compare(idata, nodeData, outputDirectory, stage, scenarios, tree); }



	void compare(const ImportData& idata, const Problem & problem, const nodeData& nodeData);

	void compare(const ImportData& idata, const nodeData& nodeData, const string& outputDirectory, const string& stage, const string& scenario,
		const string& tree);

	void compareLoop(const ImportData& idata, const Problem & problem, const nodeData& nodeData);

	void compareLayUp(const ImportData& idata, const Problem & problem, const nodeData& nodeData);

	void compareDemand(const ImportData& idata, const Problem & problem, const nodeData& nodeData);

	void compareLayUpOperatingSunset(const ImportData& idata, const Problem& problem, const nodeData& nodeData);

	void compareInstalments(const ImportData& idata, const Problem& problem, const nodeData& nodeData);

	void compareScrapping(const ImportData& idata, const Problem& problem, const nodeData& nodeData);

	void compareCostToSunSet(const ImportData& idata, const nodeData& nodeData);

	void compareLoops(const ImportData& idata, const nodeData& nodeData);		//Comparing the sailing cost for each ship type along the time horizon, deterministically

	void compareNodeLoops(const ImportData & idata, const nodeData& nodeData); //Comparing the sailing cost for each ship type along the time horizon, stochastically

	void compareNodeLayUpSavings(const ImportData & idata, const nodeData& nodeData); //Comparing the lay-up savings for each ship along the time horizon, stochastically

	void compareNodeData(const ImportData& idata, const nodeData& nodeData);

	void compareNodeDataMerged(const ImportData& idata, const nodeData& nodeData);


	void compareSailOper(const ImportData& idata, const nodeData& nodeData);

private:
	string filePath;
	const string addOptionString;
	const string instanceName;
	const string branch;
};