#include "generateTrees.h"

void generateTrees::generate(const ImportData& idata, const string & filePath, const int & numberOfStages, const int & numberOfScenarios, const int& numberOfTrees)
{
	string stages = to_string((_Longlong)numberOfStages);
	string scenarios = to_string((_Longlong)numberOfScenarios);

	string path = filePath + instanceName;

	if (CreateDirectory(path.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {		//Creating the folder _stage

		path += "\\" + stages + "_stage";
		if (CreateDirectory(path.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {		//Creating the folder _stage

			path += "\\" + scenarios + "_scenarios";

			if (CreateDirectory(path.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {	//Creating the folder _scenarios


				for (int i = 1; i <= numberOfTrees; i++) {

					string tree = to_string((_Longlong)i);

					string fullPath = path + "\\" + "Tree_" + tree;

					if (CreateDirectory(fullPath.c_str(), NULL) || ERROR_ALREADY_EXISTS == GetLastError()) {	//Creating the folder Tree_
						fullPath += "\\";
						createTree scenarioTree(idata, fullPath, numberOfStages, numberOfScenarios, branchPeriods);
					}
					else {
						string error = "Failed creating directory : " + fullPath;
						char* cstr = new char[error.length() + 1];
						strcpy_s(cstr, error.length() +1, error.c_str());
						throw cstr;
					}

				}


			}
			else {
				string error = "Failed creating directory : " + path;
				char* cstr = new char[error.length() + 1];
				strcpy_s(cstr, error.length() + 1, error.c_str());
				throw cstr;
			}

		}
		else {
			string error = "Failed creating directory : " + path;
			char* cstr = new char[error.length() + 1];
			strcpy_s(cstr, error.length() + 1, error.c_str());
			throw cstr;
		}
	}
	else {
		string error = "Failed creating directory : " + path;
		char* cstr = new char[error.length() + 1];
		strcpy_s(cstr, error.length() + 1, error.c_str());
		throw cstr;
	}

	

	

}
