
#include "importData.h"
#include "tableGenerator.h"
#include "Problem.h"
#include "model.h"
#include "createData.h"
#include "testingRobustnes.h"
#include "nodeData.h"
#include "nodeModel.h"
#include "compareData.h"
#include "createTree.h"
#include "generateTrees.h"
#include "compStudy.h"


#include <time.h>



int main(){

	try {

		int Horizon = 5;

		clock_t t1, t2;

		t1 = clock();
		vector<string> instance;
	
				
		
		instance.push_back("V18_T14_Ships51Corr");		//Making a vector with the instance names, being able to run the comutational study for several instances in one run

		//tableGenerator table;
		//table.demandTable(instance);				//A function to generate the table for demand on each trade and product

		for (int i = 0; i < instance.size(); i++) {

			string fileName = instance[i];
			string fileID = fileName + ".txt";

			CreateData dataGenerated(fileID, Horizon, "gen");		//Writing the data to a new file to check it got read properly into the model

			string fileID2 = "gen" + fileID;
			//CreateData dataTest(fileID2, Horizon, "gen");


			ImportData inputData(fileID2, 5);			//Reading the input data

			const double discountFactor = 0.12;
			int addOption = 0;						//Selecting the addOption, 0=default (excluding second hand market and charters)
													// 1 = add all, 2 = add second hand only, 3 = charters only, default = none
			int modelOption = 3;					//1 = Using the hard constraint ratio (from the specialization project), 2 = Using CVaR - constraint, 3 = using absolute cash flow constraints, default / any other number = basic model
			double confidenceLevel = 0;				//Selecting the confidence level in case a CVaR model is sovlved
			const int stages = 2;					//Selecting the number of stages
			const double Instalments = 5;			//Selecting the repayment horizon for the instalments
			const int buildTime = 2;				//Selecting the lead time
			const int scenarios = 100;				//Selecting the number of scenarios, or number of branches in each stage for a multistage model (only three-stage is implemented)
			const int branchPeriod = 3;				//The period where the nodes branch, i.e. the first two-stage period
			const double interest = 0.03;			//Setting the interest rate
			string filePathTreeGeneration = "C:\\Users\\jorge\\OneDrive\\Dokumenter\\Visual Studio 2017\\Projects\\MFRP\\MFRP\\ScenarioTrees\\";	//The path were the scenario tree is saved

			const int numberOfTrees = 20;		//The numbers of scenario trees generated

			vector<int> branchPeriods;			//The vector of branchperiods in case of running a three-stage model
			branchPeriods.push_back(3);
			branchPeriods.push_back(5);

			//generateTrees trees(inputData, filePathTreeGeneration, stages, scenarios, numberOfTrees, fileName, branchPeriods);	//Generating the scenario trees. The correlation matrix needs to be set in createTree::printCorrelation(const ImportData & idata, const int & numberOfRandoms)
																																	//Note that you have to use "branchPeriod" in case of 2-stage and "branchPeriods" in case of 3-stage

			string filePath = "C:\\Users\\jorge\\OneDrive\\Dokumenter\\Visual Studio 2017\\Projects\\MFRP\\MFRP\\";					//The path where the "Solution" folder will be created
		
			

			cout << "File: " << fileName << endl;

			for (int i = 0; i < 1; i++) {		//Possible to loop through all addOptions
				addOption = i;

				compStudy MFRP(inputData, Instalments, buildTime, stages, scenarios, branchPeriod, numberOfTrees, filePath, fileName, discountFactor, modelOption, addOption, confidenceLevel, interest);
			}
			
			//When calling the constructor of compStudy make sure to use "branchPeriod" for 2-stage run, and "branchPeriod" for 3-stage run.
			//The same has to be done to the initialization of nodeData in compStudy::comp(const ImportData& idata)

			Beep(500, 1000);
		}

		t2 = clock();

		float diff = (t2 - t1)/1000;

		cout << "The program took: " << diff << " seconds" << endl;


		}
		catch (const char* msg) {
			cerr << msg << endl;

		}

		
	
	cout << "Program done!" << endl;
	Beep(500, 1000);
	system("pause");
	return 0;
}