
#include "tableGenerator.h"

#include<fstream>

tableGenerator::tableGenerator()
{
}

void tableGenerator::generate(const nodeModel & model, const ImportData & idata, const nodeData& nodeData)
{
	
}

void tableGenerator::results(const nodeModel & model, const ImportData & idata, const nodeData& nodeData)
{
	string fullPath = pathDir + "LatexTable";

	ofstream output("Demand.txt");
	if (output.fail()) {
		char* cstr = "Could not open/create outputfile LatexTable.txt";
		throw cstr;
	}

	output << "\\begin{table}[]" << endl;
	output << "\\centering" << endl;
	output << "\\caption{Demand on each trade and product}" << endl;
	output << "\\label{tab:Demand}" << endl;
	output << "\\begin{tabular}{";

	for (int l = 1; l < idata.Time +1 ; l++) {
		output << "|l";
	}
	output << "|}" << endl;
	output << "\\hline" << endl;

	output << "Result type";

	for (int t = 1; t < idata.Time; t++) {
		output << "&" << t;
	}

	output << endl;

	output << "New builds";

	for (int t = 1; t < idata.Time; t++) {
		output << "&" << average(model.yNBNodes, nodeData, t);
	}

	output << "\\\\ \\hline" << endl;

	output << "\\end{tabular}" << endl;
	output << "\\end{table}" << endl;


	output.close();
}

double tableGenerator::average(const vector<double>& parameter, const nodeData & nodeData, const int & time)
{
	double average = 0;

	map<int, int>::const_iterator iterNodes;
	for (iterNodes = nodeData.NodesTime[time].begin(); iterNodes != nodeData.NodesTime[time].end(); iterNodes++) {
		int node = iterNodes->second;
		average += parameter[node];
	}
	average = average / nodeData.NodesTime[time].size();
	return average;
}

void tableGenerator::demandTable(const vector<string>& instances)
{
	
	/*
	vector<ImportData> idata;

	idata.resize(instances.size());
	
	for (int i = 0; i < instances.size(); i++) {
		ImportData data(instances[i] + "txt", 5);
		idata.push_back(data);
	}
	*/

	string fileID = instances[2] + ".txt";

	ImportData idata(fileID, 5);


	ofstream output("Demand.txt");
	if (output.fail()) {
		char* cstr = "Could not open/create outputfile Demand.txt";
		throw cstr;
	}


	output << "\\begin{table}[]" << endl;
	output << "\\centering" << endl;
	output << "\\caption{Demand on each trade and product}" << endl;
	output << "\\label{tab:Demand}" << endl;
	output << "\\begin{tabular}{";

	for (int l = 0; l < instances.size() + idata.nProduct + 1; l++) {
		output << "|l";
	}
	output << "|}" << endl;
	output << "\\hline" << endl;

	output << "Trades";

	map<string, int>::const_iterator iterProducts;
	for (iterProducts = idata.Product.begin(); iterProducts != idata.Product.end(); iterProducts++) {
		string product = iterProducts->first;
		output << " & " << product;
	}

	for (int j = 0; j < instances.size(); j++) {
		output << " & " << "Instance " << (j+1);
	}

	output << " \\\\ \\hline" << endl;

	map<string, int>::const_iterator iterTrades;
	for (iterTrades = idata.Trades.begin(); iterTrades != idata.Trades.end(); iterTrades++) {
		string trade = iterTrades->first;
		int i = iterTrades->second;

		output << trade;

		map<string, int>::const_iterator iterProducts;
		for (iterProducts = idata.Product.begin(); iterProducts != idata.Product.end(); iterProducts++) {
			int k = iterProducts->second;

			output << " & " << idata.Demand[i][k][1];
		}

		for (int j = 0; j < instances.size(); j++) {

			string fileIDtest = instances[j] + ".txt";
			ImportData testData(fileIDtest, 5);

			bool flag = true;

			map<string, int>::const_iterator iterTradesC;
			for (iterTradesC = testData.TradesC.begin(); iterTradesC != testData.TradesC.end(); iterTradesC++) {
				string tradeC = iterTradesC->first;
				int iC = iterTradesC->second;

				if (trade == tradeC) {
					output << " & " << "C";
					flag = false;
					break;
				}
			}
			if (flag) {
				map<string, int>::const_iterator iterTradesO;
				for (iterTradesO = testData.TradesO.begin(); iterTradesO != testData.TradesO.end(); iterTradesO++) {
					string tradeO = iterTradesO->first;
					int iO = iterTradesO->second;


					if (trade == tradeO) {
						output << " & " << "O";
						flag = false;
						break;
					}
				}
			}

			if (flag) {
				output << " & " << "-";
			}
		}

		output << " \\\\ \\hline" << endl;
	}


	output << "\\end{tabular}" << endl;
	output << "\\end{table}" << endl;





	output.close();
	
	
}
