
name = 'V18_T14_Ships51S=50L=2.3'
dataFile = name.'.txt'

reset
unset arrow

set termoption dash
set linetype 2 dt 2
set linetype 22 dt 3

set style fill solid 0.25 border -1
set style boxplot fraction 1
set style data boxplot
set grid lt -1 dt 3

set style line 1 lt 2 lc rgb "red" lw 1
set style line 2 lt 22 lc rgb "blue" lw 1

set xlabel 'Period [year]'
set ylabel 'Cash flow'
set title ''
set xtics ('1' 2, '2' 3, '3' 4, '4' 5, '5' 6)

set format x "%.0f" 
set format y "%.0f"

set yrange [-100:710]

do for [i=2:6] {
    stats dataFile using (i):i nooutput
    set label i sprintf('%.1f', STATS_stddev_y) center at STATS_mean_x,STATS_max_y offset 0,1
}


set term win

plot for [i=2:6] dataFile using (i):i dt 1 notitle, dataFile using ($0+1):7 with lines ls 1 notitle, dataFile using ($0+1):8 with lines ls 2 notitle

set term pngcairo
set output 'C:\Users\jorge\Dropbox\gnuPlot\Figures\Box_Plot\'.name.'_box.png'
replot
