reset

name = 'FrontierMedium'
name1 = 'FrontierV18_T9_Ships37Corr'
name2 = 'FrontierV18_T9_Ships37'
name3 = 'FrontierV18_T9_Ships37CorrS50'
name4 = 'FrontierV18_T9_Ships37S=50'
dataFile1 = name1.'.txt'
dataFile2 = name2.'.txt'
dataFile3 = name3.'.txt'
dataFile4 = name4.'.txt'


unset arrow

set termoption dash


set style line 1 lt 15 lw 2 dt 1
set style line 2 lt 15 lw 2 dt 2
set style line 3 lt 19 lw 2 dt 1
set style line 4 lt 19 lw 2 dt 2

set xlabel 'Relative worst case cash flow [Worst case cash flow/annualised expected profit]' offset 1,0
set y2label 'Relative expected profit loss'
set title ''

set format x "%.0f%%" 
set format y2 "%.0f%%" 

set noytics

set y2tics nomirror

set grid xtics y2tics

set xrange [-40:15]
set y2range[-1:15]

set key top left
set term win

plot 	dataFile1 using ($1*100):($2*100) with lines ls 1 title 'Correlated 100% SCP' axis x1y2,\
	dataFile2 using ($1*100):($2*100) with lines ls 2 title 'Uncorrelated 100% SCP' axis x1y2, \
	dataFile3 using ($1*100):($2*100) with lines ls 3 title 'Correlated 50% SCP' axis x1y2, \
	dataFile4 using ($1*100):($2*100) with lines ls 4 title 'Uncorrelated 50% SCP' axis x1y2

set term pngcairo
set output 'C:\Users\jorge\Dropbox\gnuPlot\Figures\Frontiers\'.name.'.png'
replot
