reset

name = 'FrontierCVaR'
name1 = 'FrontierV18_T14_Ships51CorrCVaR99'
name2 = 'FrontierV18_T14_Ships51CorrCVaR95'
name3 = 'FrontierV18_T14_Ships51CorrCVaR90'
dataFile1 = name1.'.txt'
dataFile2 = name2.'.txt'
dataFile3 = name3.'.txt'


unset arrow

set encoding utf8

set termoption dash
set termoption enhanced


set style line 1 lt 15 lw 2 dt 1
set style line 2 lt 4 lw 2 dt 2
set style line 3 lt 19 lw 2 dt 3

set xlabel 'Relative expected cash flow limit [Expected cash flow limit/annualised expected profit]' offset 2,0
set y2label 'Relative expected profit loss'
set title ''

set format x "%.0f%%" 
set format y2 "%.0f%%" 

set noytics

set y2tics nomirror

set grid xtics y2tics

set xrange [-31:10]
set y2range[-1:15]

set key top left
set term win

plot 	dataFile1 using ($1*100):($2*100) with lines ls 1 title 'Confidence level = 0.99' axis x1y2,\
	dataFile2 using ($1*100):($2*100) with lines ls 2 title 'Confidence level = 0.95' axis x1y2, \
	dataFile3 using ($1*100):($2*100) with lines ls 3 title 'Confidence level = 0.90' axis x1y2, \
	
set term pngcairo
set output 'C:\Users\jorge\Dropbox\gnuPlot\Figures\Frontiers\'.name.'.png'
replot
